



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>CGLIB学习笔记</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">CGLIB学习笔记</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-27 08:50:04 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1><strong>0 概述 </strong></h1>
<p>CGLIB基于ASM实现。提供比反射更为强大的动态特性。使用CGLIB可以非常方便的实现的动态代理。</p>
<h2><strong>0.1 CGLIB包结构 </strong></h2>
<ul><li><div><em>net.sf.cglib.core &nbsp; &nbsp;</em>底层字节码处理类。</div></li>
<li><div><em>net.sf.cglib.transform &nbsp; &nbsp;</em>该包中的类用于class文件运行时转换或编译时转换。</div></li>
<li><div><em>net.sf.cglib.proxy &nbsp; &nbsp;</em>该包中的类用于创建代理和方法拦截。</div></li>
<li><div><em>net.sf.cglib.reflect &nbsp; &nbsp;</em>该包中的类用于快速反射，并提供了C#风格的委托。</div></li>
<li><div><em>net.sf.cglib.util &nbsp; &nbsp;</em>集合排序工具类。</div></li>
<li><div><em>net.sf.cglib.beans &nbsp; &nbsp;</em>JavaBean工具类。</div></li></ul>
<h1><strong>1 使用CGLIB实现动态代理 </strong></h1>
<h2><strong>1.1 CGLIB代理相关的类 </strong></h2>
<ul><li><em>net.sf.cglib.proxy.Enhancer</em>&nbsp;&nbsp;&nbsp;&nbsp;主要的增强类。</li>
<li><em>net.sf.cglib.proxy.MethodInterceptor</em>&nbsp;&nbsp;&nbsp;&nbsp;主要的方法拦截类，它是Callback接口的子接口，需要用户实现。</li>
<li><em>net.sf.cglib.proxy.MethodProxy</em>&nbsp;&nbsp;&nbsp;&nbsp;JDK的java.lang.reflect.Method类的代理类，可以方便的实现对源对象方法的调用。</li></ul>
<p>cglib是通过动态的生成一个子类去覆盖所要代理类的非final方法，并设置好callback，则原有类的每个方法调用就会转变成调用用户定义的拦截方法（interceptors）。</p>
<p>CGLIB代理相关的常用API如下图所示：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/453361/201311/18161832-72bbdf5d70544bd2b1b895be65813a68.png" /></p>
<p>net.sf.cglib.proxy.Callback接口在CGLIB包中是一个重要的接口，所有被net.sf.cglib.proxy.Enhancer类调用的回调（callback）接口都要继承这个接口。</p>
<p>net.sf.cglib.proxy.MethodInterceptor能够满足任何的拦截（interception&nbsp;）需要。对有些情况下可能过度。为了简化和提高性能，CGLIB包提供了一些专门的回调（callback）类型：</p>
<ul><li><em>net.sf.cglib.proxy.FixedValue</em> 为提高性能，FixedValue回调对强制某一特别方法返回固定值是有用的。</li>
<li><em>net.sf.cglib.proxy.NoOp</em> NoOp回调把对方法调用直接委派到这个方法在父类中的实现。</li>
<li><em>net.sf.cglib.proxy.LazyLoader</em> 当实际的对象需要延迟装载时，可以使用LazyLoader回调。一旦实际对象被装载，它将被每一个调用代理对象的方法使用。</li>
<li><em>net.sf.cglib.proxy.Dispatcher</em> Dispathcer回调和LazyLoader回调有相同的特点，不同的是，当代理方法被调用时，装载对象的方法也总要被调用。</li>
<li><em>net.sf.cglib.proxy.ProxyRefDispatcher</em> ProxyRefDispatcher回调和Dispatcher一样，不同的是，它可以把代理对象作为装载对象方法的一个参数传递。</li></ul>
<h2><strong>1.2 CGLIB动态代理的基本原理 </strong></h2>
<p>CGLIB动态代理的原理就是用Enhancer生成一个原有类的子类，并且设置好callback到proxy， 则原有类的每个方法调用都会转为调用实现了MethodInterceptor接口的proxy的intercept() 函数，如图</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/453361/201311/18161834-a33b9d78cc5e487d97a383a904f34230.png" /></p>
<p>在intercept()函数里，除执行代理类的原因方法，在原有方法前后加入其他需要实现的过程，改变原有方法的参数值，即可以实现对原有类的代理了。这似于AOP中的around advice。</p>
<h2><strong>1.3 使用MethodInterceptor接口实现方法回调 </strong></h2>
<p>当对代理中所有方法的调用时，都会转向MethodInterceptor类型的拦截（intercept）方法,在拦截方法中再调用底层对象相应的方法。下面我们举个例子，假设你想对目标对象的所有方法调用进行权限的检查，如果没有经过授权，就抛出一个运行时的异常。</p>
<p>net.sf.cglib.proxy.MethodInterceptor接口是最通用的回调（callback）类型，它经常被基于代理的AOP用&nbsp;来实现拦截（intercept）方法的调用。</p>
<p>MethodInterceptor接口只定义了一个方法：</p>
<p><em>public&nbsp;Object&nbsp;<strong>intercept</strong>(Object&nbsp;object,&nbsp;java.lang.reflect.Method&nbsp;method,&nbsp;Object[]&nbsp;args,&nbsp;MethodProxy&nbsp;proxy)&nbsp;throws&nbsp;Throwable; </em></p>
<p>参数<em>Object&nbsp;object</em>是被代理对象，不会出现死循环的问题。</p>
<p>参数<em>java.lang.reflect.Method&nbsp;method</em>是java.lang.reflect.Method类型的被拦截方法。</p>
<p>参数<em>Object[]&nbsp;args</em>是被被拦截方法的参数。</p>
<p>参数<em>MethodProxy&nbsp;proxy</em>是CGLIB提供的MethodProxy&nbsp;类型的被拦截方法。</p>
<p>注意：</p>
<p>1、若原方法的参数存在基本类型，则对于第三个参数Object[]&nbsp;args会被转化成类的类型。如原方法的存在一个参数为int，则在intercept方法中，对应的会存在一个Integer类型的参数。</p>
<p>2、若原方法为final方法，则MethodInterceptor接口无法拦截该方法。</p>
<h3><strong>1.3.1 实现MethodInterceptor接口 </strong></h3>
<p><strong>class</strong> MethodInterceptorImpl <strong>implements</strong> MethodInterceptor {</p>
<p>@Override</p>
<p><strong>public</strong> Object intercept(Object obj, Method method, Object[] args, MethodProxy proxy) <strong>throws</strong> Throwable {</p>
<p>System.<em>out</em>.println("Before invoke " + method);</p>
<p>Object result = proxy.invokeSuper(obj, args);</p>
<p>System.<em>out</em>.println("After invoke" + method);</p>
<p><strong>return</strong> result;</p>
<p>}</p>
<p>}</p>
<p><em>Object result=proxy.invokeSuper(o,args); </em>表示调用原始类的被拦截到的方法。这个方法的前后添加需要的过程。在这个方法中，我们可以在调用原方法之前或之后注入自己的代码。</p>
<p>由于性能的原因，对原始方法的调用使用CGLIB的net.sf.cglib.proxy.MethodProxy对象，而不是反射中一般使用java.lang.reflect.Method对象。</p>
<h2><strong>1.4 使用CGLIB代理最核心类Enhancer生成代理对象 </strong></h2>
<p>net.sf.cglib.proxy.Enhancer中有几个常用的方法：</p>
<ul><li><em>void <strong>setSuperclass</strong>(java.lang.Class superclass) </em> 设置产生的代理对象的父类。</li>
<li><em>void <strong>setCallback</strong>(Callback callback)</em> 设置CallBack接口的实例。</li>
<li><em>void <strong>setCallbacks</strong>(Callback[] callbacks)</em> 设置多个CallBack接口的实例。</li>
<li><em>void <strong>setCallbackFilter</strong>(CallbackFilter filter)</em> 设置方法回调过滤器。</li>
<li><em>Object <strong>create</strong>()</em> 使用默认无参数的构造函数创建目标对象。</li>
<li><em>Object <strong>create</strong>(Class[],&nbsp;Object[])</em> 使用有参数的构造函数创建目标对象。参数Class[] 定义了参数的类型，第二个Object[]是参数的值。</li></ul>
<p>注意：在参数中，基本类型应被转化成类的类型。</p>
<p>基本代码：</p>
<p><strong>public</strong> Object createProxy(Class targetClass) {</p>
<p>Enhancer enhancer = <strong>new</strong> Enhancer();</p>
<p>enhancer.setSuperclass(targetClass);</p>
<p>enhancer.setCallback(<strong>new</strong> MethodInterceptorImpl ());</p>
<p><strong>return</strong> enhancer.create();</p>
<p>}</p>
<p>createProxy方法返回值是targetClass的一个实例的代理。</p>
<h2><strong>1.5 使用CGLIB继进行动态代理示例 </strong></h2>
<p>例1：使用CGLIB生成代理的基本使用。</p>
<p><strong>import</strong> java.lang.reflect.Method;</p>
<p><strong>import</strong> net.sf.cglib.proxy.Enhancer;</p>
<p><strong>import</strong> net.sf.cglib.proxy.MethodInterceptor;</p>
<p><strong>import</strong> net.sf.cglib.proxy.MethodProxy;</p>
<p><strong>public</strong> <strong>class</strong> TestMain {</p>
<p><strong>public</strong> <strong>static</strong> <strong>void</strong> main(String[] args) {</p>
<p>Enhancer enhancer = <strong>new</strong> Enhancer();</p>
<p>enhancer.setSuperclass(Cglib.<strong>class</strong>);</p>
<p>enhancer.setCallback(<strong>new</strong> HelloProxy());</p>
<p>Cglib cglibProxy = (Cglib)enhancer.create();</p>
<p>cglibProxy.cglib();</p>
<p>}</p>
<p>}</p>
<p><strong>class</strong> Cglib{</p>
<p><strong>public</strong> <strong>void</strong> cglib(){</p>
<p>System.<em>out</em>.println("CGLIB");</p>
<p>}</p>
<p>}</p>
<p><strong>class</strong> HelloProxy <strong>implements</strong> MethodInterceptor{</p>
<p>@Override</p>
<p><strong>public</strong> Object intercept(Object obj, Method method, Object[] args, MethodProxy proxy) <strong>throws</strong> Throwable {</p>
<p>System.<em>out</em>.println("Hello");</p>
<p>Object object = proxy.invokeSuper(obj, args);</p>
<p>System.<em>out</em>.println("Powerful!");</p>
<p><strong>return</strong> object;</p>
<p>}</p>
<p>}</p>
<p>输出内容：</p>
<p>Hello</p>
<p>CGLIB</p>
<p>Powerful!</p>
<p>例2：使用CGLIB创建一个Dao工厂，并展示一些基本特性。</p>
<p><strong>public</strong> <strong>interface</strong> Dao {</p>
<p><strong>void</strong> add(Object o);</p>
<p><strong>void</strong> add(<strong>int</strong> i);</p>
<p><strong>void</strong> add(String s);</p>
<p>}</p>
<p><strong>public</strong> <strong>class</strong> DaoImpl <strong>implements</strong> Dao {</p>
<p>@Override</p>
<p><strong>public</strong> <strong>void</strong> add(Object o) {</p>
<p>System.<em>out</em>.println("add(Object o)");</p>
<p>}</p>
<p>@Override</p>
<p><strong>public</strong> <strong>void</strong> add(<strong>int</strong> i) {</p>
<p>System.<em>out</em>.println("add(int i)");</p>
<p>}</p>
<p><strong>public</strong> <strong>final</strong> <strong>void</strong> add(String s) {</p>
<p>System.<em>out</em>.println("add(String s)");</p>
<p>}</p>
<p>}</p>
<p><strong>public</strong> <strong>class</strong> Proxy <strong>implements</strong> MethodInterceptor {</p>
<p>@Override</p>
<p><strong>public</strong> Object intercept(Object obj, Method method, Object[] args, MethodProxy proxy) <strong>throws</strong> Throwable {</p>
<p>System.<em>out</em>.println("拦截前...");</p>
<p>// 输出参数类型</p>
<p><strong>for</strong> (Object arg : args) {</p>
<p>System.<em>out</em>.print(arg.getClass() + ";");</p>
<p>}</p>
<p>Object result = proxy.invokeSuper(obj, args);</p>
<p>System.<em>out</em>.println("拦截后...");</p>
<p><strong>return</strong> result;</p>
<p>}</p>
<p>}</p>
<p><strong>public</strong> <strong>class</strong> DaoFactory {</p>
<p><strong>public</strong> <strong>static</strong> Dao create() {</p>
<p>Enhancer enhancer = <strong>new</strong> Enhancer();</p>
<p>enhancer.setSuperclass(DaoImpl.<strong>class</strong>);</p>
<p>enhancer.setCallback(<strong>new</strong> Proxy());</p>
<p>Dao dao = (Dao) enhancer.create();</p>
<p><strong>return</strong> dao;</p>
<p>}</p>
<p>}</p>
<p><strong>public</strong> <strong>class</strong> TestMain {</p>
<p><strong>public</strong> <strong>static</strong> <strong>void</strong> main(String[] args) {</p>
<p>Dao dao = DaoFactory.<em>create</em>();</p>
<p>dao.add(<strong>new</strong> Object());</p>
<p>dao.add(1);</p>
<p>dao.add("1");</p>
<p>}</p>
<p>}</p>
<p>输出内容：</p>
<p>拦截前...</p>
<p>class java.lang.Object;add(Object o)</p>
<p>拦截后...</p>
<p>拦截前...</p>
<p>class java.lang.Integer;add(int i)</p>
<p>拦截后...</p>
<p>add(String s)</p>
<h1><strong>2 回调过滤器CallbackFilter </strong></h1>
<p>net.sf.cglib.proxy.CallbackFilter有选择的对一些方法使用回调。</p>
<p>CallbackFilter可以实现不同的方法使用不同的回调方法。所以CallbackFilter称为"回调选择器"更合适一些。</p>
<p>CallbackFilter中的accept方法，根据不同的method返回不同的值i，这个值是在callbacks中callback对象的序号，就是调用了callbacks[i]。</p>
<p><strong>import</strong> java.lang.reflect.Method;</p>
<p><strong>import</strong> net.sf.cglib.proxy.Callback;</p>
<p><strong>import</strong> net.sf.cglib.proxy.CallbackFilter;</p>
<p><strong>import</strong> net.sf.cglib.proxy.Enhancer;</p>
<p><strong>import</strong> net.sf.cglib.proxy.MethodInterceptor;</p>
<p><strong>import</strong> net.sf.cglib.proxy.MethodProxy;</p>
<p><strong>import</strong> net.sf.cglib.proxy.NoOp;</p>
<p><strong>public</strong> <strong>class</strong> CallbackFilterDemo {</p>
<p><strong>public</strong> <strong>static</strong> <strong>void</strong> main(String[] args) {</p>
<p>// 回调实例数组</p>
<p>Callback[] callbacks = <strong>new</strong> Callback[] { <strong>new</strong> MethodInterceptorImpl(), NoOp.<em>INSTANCE</em> };</p>
<p>// 使用enhancer，设置相关参数。</p>
<p>Enhancer enhancer = <strong>new</strong> Enhancer();</p>
<p>enhancer.setSuperclass(User.<strong>class</strong>);</p>
<p>enhancer.setCallbacks(callbacks);</p>
<p>enhancer.setCallbackFilter(<strong>new</strong> CallbackFilterImpl());</p>
<p>// 产生代理对象</p>
<p>User proxyUser = (User) enhancer.create();</p>
<p>proxyUser.pay(); // 买</p>
<p>proxyUser.eat(); // 吃</p>
<p>}</p>
<p>/**</p>
<p>* 回调过滤器类。</p>
<p>*/</p>
<p><strong>private</strong> <strong>static</strong> <strong>class</strong> CallbackFilterImpl <strong>implements</strong> CallbackFilter {</p>
<p>@Override</p>
<p><strong>public</strong> <strong>int</strong> accept(Method method) {</p>
<p>String methodName = method.getName();</p>
<p><strong>if</strong> ("eat".equals(methodName)) {</p>
<p><strong>return</strong> 1; // eat()方法使用callbacks[1]对象拦截。</p>
<p>} <strong>else</strong> <strong>if</strong> ("pay".equals(methodName)) {</p>
<p><strong>return</strong> 0; // pay()方法使用callbacks[0]对象拦截。</p>
<p>}</p>
<p><strong>return</strong> 0;</p>
<p>}</p>
<p>}</p>
<p>/**</p>
<p>* 自定义回调类。</p>
<p>*/</p>
<p><strong>private</strong> <strong>static</strong> <strong>class</strong> MethodInterceptorImpl <strong>implements</strong> MethodInterceptor {</p>
<p>@Override</p>
<p><strong>public</strong> Object intercept(Object obj, Method method, Object[] args, MethodProxy proxy) <strong>throws</strong> Throwable {</p>
<p>System.<em>out</em>.println("Before invoke " + method);</p>
<p>Object result = proxy.invokeSuper(obj, args); // 原方法调用。</p>
<p>System.<em>out</em>.println("After invoke" + method);</p>
<p><strong>return</strong> result;</p>
<p>}</p>
<p>}</p>
<p>}</p>
<p><strong>class</strong> User {</p>
<p><strong>public</strong> <strong>void</strong> pay() {</p>
<p>System.<em>out</em>.println("买东西");</p>
<p>}</p>
<p><strong>public</strong> <strong>void</strong> eat() {</p>
<p>System.<em>out</em>.println("吃东西");</p>
<p>}</p>
<p>}</p>
<p>输出结果：</p>
<p>Before invoke public void sjq.cglib.filter.User.pay()</p>
<p>pay()</p>
<p>After invokepublic void sjq.cglib.filter.User.pay()</p>
<p>eat()</p>
<h1><strong>3 CGLIB对Mixin的支持 </strong></h1>
<p>CGLIB的代理包net.sf.cglib.proxy.Mixin类提供对Minix编程的支持。Minix允许多个对象绑定到一个单个的大对象上。在代理中对方法的调用委托到下面相应的对象中。&nbsp;这是一种将多个接口混合在一起的方式, 实现了多个接口。</p>
<p>Minix是一种多继承的替代方案, 很大程度上解决了多继承的很多问题, 实现和理解起来都比较容易。</p>
<p><strong>import</strong> net.sf.cglib.proxy.Mixin;</p>
<p><strong>public</strong> <strong>class</strong> MixinDemo {</p>
<p><strong>public</strong> <strong>static</strong> <strong>void</strong> main(String[] args) {</p>
<p>//接口数组</p>
<p>Class&lt;?&gt;[] interfaces = <strong>new</strong> Class[] { MyInterfaceA.<strong>class</strong>, MyInterfaceB.<strong>class</strong> };</p>
<p>//实例对象数组</p>
<p>Object[] delegates = <strong>new</strong> Object[] { <strong>new</strong> MyInterfaceAImpl(), <strong>new</strong> MyInterfaceBImpl() };</p>
<p>//Minix组合为o对象。</p>
<p>Object o = Mixin.<em>create</em>(interfaces, delegates);</p>
<p>MyInterfaceA a = (MyInterfaceA) o;</p>
<p>a.methodA();</p>
<p>MyInterfaceB b = (MyInterfaceB) o;</p>
<p>b.methodB();</p>
<p>System.<em>out</em>.println("\r\n 输出Mixin对象的结构...");</p>
<p>Class clazz = o.getClass();</p>
<p>Method[] methods = clazz.getDeclaredMethods();</p>
<p><strong>for</strong> (<strong>int</strong> i = 0; i &lt; methods.length; i++) {</p>
<p>System.<em>out</em>.println(methods[i].getName());</p>
<p>}</p>
<p>System.<em>out</em>.println(clazz);</p>
<p>}</p>
<p>}</p>
<p><strong>interface</strong> MyInterfaceA {</p>
<p><strong>public</strong> <strong>void</strong> methodA();</p>
<p>}</p>
<p><strong>interface</strong> MyInterfaceB {</p>
<p><strong>public</strong> <strong>void</strong> methodB();</p>
<p>}</p>
<p><strong>class</strong> MyInterfaceAImpl <strong>implements</strong> MyInterfaceA {</p>
<p>@Override</p>
<p><strong>public</strong> <strong>void</strong> methodA() {</p>
<p>System.<em>out</em>.println("MyInterfaceAImpl.methodA()");</p>
<p>}</p>
<p>}</p>
<p><strong>class</strong> MyInterfaceBImpl <strong>implements</strong> MyInterfaceB {</p>
<p>@Override</p>
<p><strong>public</strong> <strong>void</strong> methodB() {</p>
<p>System.<em>out</em>.println("MyInterfaceBImpl.methodB()");</p>
<p>}</p>
<p>}</p>
<p>输出结果：</p>
<p>MyInterfaceAImpl.methodA()</p>
<p>MyInterfaceBImpl.methodB()</p>
<p>输出Mixin对象的结构...</p>
<p>methodA</p>
<p>methodB</p>
<p>newInstance</p>
<p>class sjq.cglib.mixin.MyInterfaceA$$MixinByCGLIB$$d1f6261a</p>
<h1><strong>4 CGLIB用来对象之间拷贝属性 </strong></h1>
<p><strong>package</strong> sjq.cglib.bean.copy;</p>
<p><strong>import</strong> net.sf.cglib.beans.BeanCopier;</p>
<p><strong>public</strong> <strong>class</strong> PropertyCopyDemo {</p>
<p><strong>public</strong> <strong>static</strong> <strong>void</strong> main(String[] args) {</p>
<p>//两个对象</p>
<p>Other other = <strong>new</strong> Other("test", "1234");</p>
<p>Myth myth = <strong>new</strong> Myth();</p>
<p>System.<em>out</em>.println(other);</p>
<p>System.<em>out</em>.println(myth);</p>
<p>//构建BeanCopier,并copy对象的属性值。</p>
<p>BeanCopier copier = BeanCopier.<em>create</em>(Other.<strong>class</strong>, Myth.<strong>class</strong>, <strong>false</strong>);</p>
<p>copier.copy(other, myth, <strong>null</strong>);</p>
<p>System.<em>out</em>.println(other);</p>
<p>System.<em>out</em>.println(myth);</p>
<p>}</p>
<p>}</p>
<p><strong>class</strong> Other {</p>
<p><strong>private</strong> String username;</p>
<p><strong>private</strong> String password;</p>
<p><strong>private</strong> <strong>int</strong> age;</p>
<p><strong>public</strong> String getUsername() {</p>
<p><strong>return</strong> username;</p>
<p>}</p>
<p><strong>public</strong> <strong>void</strong> setUsername(String username) {</p>
<p><strong>this</strong>.username = username;</p>
<p>}</p>
<p><strong>public</strong> String getPassword() {</p>
<p><strong>return</strong> password;</p>
<p>}</p>
<p><strong>public</strong> <strong>void</strong> setPassword(String password) {</p>
<p><strong>this</strong>.password = password;</p>
<p>}</p>
<p><strong>public</strong> Other(String username, String password) {</p>
<p><strong>super</strong>();</p>
<p><strong>this</strong>.username = username;</p>
<p><strong>this</strong>.password = password;</p>
<p>}</p>
<p>@Override</p>
<p><strong>public</strong> String toString() {</p>
<p><strong>return</strong> "Other: " + username + ", " + password + ", " + age;</p>
<p>}</p>
<p><strong>public</strong> <strong>int</strong> getAge() {</p>
<p><strong>return</strong> age;</p>
<p>}</p>
<p><strong>public</strong> <strong>void</strong> setAge(<strong>int</strong> age) {</p>
<p><strong>this</strong>.age = age;</p>
<p>}</p>
<p>}</p>
<p><strong>class</strong> Myth {</p>
<p><strong>private</strong> String username;</p>
<p><strong>private</strong> String password;</p>
<p><strong>private</strong> String remark;</p>
<p><strong>public</strong> String getUsername() {</p>
<p><strong>return</strong> username;</p>
<p>}</p>
<p><strong>public</strong> <strong>void</strong> setUsername(String username) {</p>
<p><strong>this</strong>.username = username;</p>
<p>}</p>
<p><strong>public</strong> String getPassword() {</p>
<p><strong>return</strong> password;</p>
<p>}</p>
<p><strong>public</strong> <strong>void</strong> setPassword(String password) {</p>
<p><strong>this</strong>.password = password;</p>
<p>}</p>
<p>@Override</p>
<p><strong>public</strong> String toString() {</p>
<p><strong>return</strong> "Myth: " + username + ", " + password + ", " + remark;</p>
<p>}</p>
<p><strong>public</strong> <strong>void</strong> setRemark(String remark) {</p>
<p><strong>this</strong>.remark = remark;</p>
<p>}</p>
<p><strong>public</strong> String getRemark() {</p>
<p><strong>return</strong> remark;</p>
<p>}</p>
<p>}</p>
<p>运行结果如下：</p>
<p>Other: test, 1234, 0</p>
<p>Myth: null, null, null</p>
<p>Other: test, 1234, 0</p>
<p>Myth: test, 1234, null</p>
<h1><strong>5 使用CGLIB动态生成Bean</strong></h1>
<p><strong>import</strong> java.util.Iterator;</p>
<p><strong>import</strong> java.util.Map;</p>
<p><strong>import</strong> java.util.Set;</p>
<p><strong>import</strong> net.sf.cglib.beans.BeanGenerator;</p>
<p><strong>import</strong> net.sf.cglib.beans.BeanMap;</p>
<p>/**</p>
<p>*动态实体bean</p>
<p>*/</p>
<p><strong>public</strong> <strong>class</strong> CglibBean {</p>
<p>/**</p>
<p>* 实体Object</p>
<p>*/</p>
<p><strong>public</strong> Object object = <strong>null</strong>;</p>
<p>/**</p>
<p>* 属性map</p>
<p>*/</p>
<p><strong>public</strong> BeanMap beanMap = <strong>null</strong>;</p>
<p><strong>public</strong> CglibBean() {</p>
<p><strong>super</strong>();</p>
<p>}</p>
<p>@SuppressWarnings("unchecked")</p>
<p><strong>public</strong> CglibBean(Map&lt;String, Class&gt; propertyMap) {</p>
<p><strong>this</strong>.object = generateBean(propertyMap);</p>
<p><strong>this</strong>.beanMap = BeanMap.<em>create</em>(<strong>this</strong>.object);</p>
<p>}</p>
<p>/**</p>
<p>* 给bean属性赋值</p>
<p>* <strong>@param</strong> property属性名</p>
<p>* <strong>@param</strong> value值</p>
<p>*/</p>
<p><strong>public</strong> <strong>void</strong> setValue(String property, Object value) {</p>
<p>beanMap.put(property, value);</p>
<p>}</p>
<p>/**</p>
<p>* 通过属性名得到属性值</p>
<p>* <strong>@param</strong> property属性名</p>
<p>*/</p>
<p><strong>public</strong> Object getValue(String property) {</p>
<p><strong>return</strong> beanMap.get(property);</p>
<p>}</p>
<p>/**</p>
<p>* 得到该实体bean对象。</p>
<p>*/</p>
<p><strong>public</strong> Object getObject() {</p>
<p><strong>return</strong> <strong>this</strong>.object;</p>
<p>}</p>
<p>/**</p>
<p>* 生成Bean</p>
<p>* <strong>@param</strong> propertyMap</p>
<p>* <strong>@return</strong></p>
<p>*/</p>
<p>@SuppressWarnings("unchecked")</p>
<p><strong>private</strong> Object generateBean(Map&lt;String, Class&gt; propertyMap) {</p>
<p>BeanGenerator generator = <strong>new</strong> BeanGenerator();</p>
<p>Set keySet = propertyMap.keySet();</p>
<p><strong>for</strong> (Iterator i = keySet.iterator(); i.hasNext();) {</p>
<p>String key = (String) i.next();</p>
<p>generator.addProperty(key, (Class) propertyMap.get(key));</p>
<p>}</p>
<p><strong>return</strong> generator.create();</p>
<p>}</p>
<p>}</p>
<p>测试并使用动态Bean</p>
<p><strong>import</strong> java.lang.reflect.Method;</p>
<p><strong>import</strong> java.util.HashMap;</p>
<p>/**</p>
<p>* Cglib测试类</p>
<p>*/</p>
<p><strong>public</strong> <strong>class</strong> CglibTest {</p>
<p>@SuppressWarnings("unchecked")</p>
<p><strong>public</strong> <strong>static</strong> <strong>void</strong> main(String[] args) <strong>throws</strong> ClassNotFoundException {</p>
<p>// 设置类成员属性</p>
<p>HashMap&lt;String, Class&gt; propertyMap = <strong>new</strong> HashMap&lt;String, Class&gt;();</p>
<p>propertyMap.put("id", Class.<em>forName</em>("java.lang.Integer"));</p>
<p>propertyMap.put("name", Class.<em>forName</em>("java.lang.String"));</p>
<p>propertyMap.put("address", Class.<em>forName</em>("java.lang.String"));</p>
<p>// 生成动态Bean</p>
<p>CglibBean bean = <strong>new</strong> CglibBean(propertyMap);</p>
<p>// 给Bean设置值</p>
<p>bean.setValue("id", <strong>new</strong> Integer(123));</p>
<p>bean.setValue("name", "454");</p>
<p>bean.setValue("address", "789");</p>
<p>// 从Bean中获取值，当然了获得值的类型是Object</p>
<p>System.<em>out</em>.println("&gt;&gt;id=" + bean.getValue("id"));</p>
<p>System.<em>out</em>.println("&gt;&gt;name=" + bean.getValue("name"));</p>
<p>System.<em>out</em>.println("&gt;&gt;address=" + bean.getValue("address"));// 获得bean的实体</p>
<p>Object object = bean.getObject();</p>
<p>// 通过反射查看所有方法名</p>
<p>Class clazz = object.getClass();</p>
<p>Method[] methods = clazz.getDeclaredMethods();</p>
<p><strong>for</strong> (<strong>int</strong> i = 0; i &lt; methods.length; i++) {</p>
<p>System.<em>out</em>.println(methods[i].getName());</p>
<p>}</p>
<p>}</p>
<p>}</p>
<p>输出：</p>
<p>&gt;&gt;id=123</p>
<p>&gt;&gt;name=454</p>
<p>&gt;&gt;address=789</p>
<p>setId</p>
<p>getAddress</p>
<p>getName</p>
<p>getId</p>
<p>setName</p>
<p>setAddress</p>
<p>class net.sf.cglib.empty.Object$$BeanGeneratorByCGLIB$$1d39cfaa</p>
<p>本篇学习文档参考于：</p>
<p><a href="http://jnb.ociweb.com/jnb/jnbNov2005.html" rel="external nofollow noreferrer">http://jnb.ociweb.com/jnb/jnbNov2005.html</a></p>
<p><a href="http://wenku.baidu.com/view/3f92297c27284b73f24250b9.html" rel="external nofollow noreferrer">http://wenku.baidu.com/view/3f92297c27284b73f24250b9.html</a></p>
<p><a href="http://www.cnblogs.com/icejoywoo/" rel="external nofollow noreferrer">http://www.cnblogs.com/icejoywoo/</a></p>
<p><a href="http://www.blogjava.net/calvin/archive/2005/11/28/21741.html" rel="external nofollow noreferrer">http://www.blogjava.net/calvin/archive/2005/11/28/21741.html</a></p>
<p><a href="http://m635674608.iteye.com/blog/1435221" rel="external nofollow noreferrer">http://m635674608.iteye.com/blog/1435221</a><br />
		等其他高手博客提供的资料。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn5x1gq.html">windows8&period;1下常用编辑器安装配置&lpar;emacs&sol;vim&sol;sublime text3&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ore6x8.html">&lbrack;课程设计&rsqb;Scrum 1&period;6 多鱼点餐系统开发进度（点餐页面按钮添加&amp;amp&semi;修复）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r932p1gq.html">&lbrack;hadoop&rsqb; 一些基础概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/3903v539.html">ubuntu14&period;04网络设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1gv2n9.html">json和字符串&sol;数组&sol;集合的互相转换の神操作总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e15rmj9.html">Google Test资料</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde460x9.html">Qt中QWidget加入到父类QWidget不能显示的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1zl6m9.html">&lpar;转&rpar;linux下fork的运行机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpj2179.html">Microsoft &period;NET Pet Shop 简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z30rx9.html">Django将request对象传入模板配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8megj32q.html">java 虚拟机内存模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25g0xxq.html">python if &lowbar;&lowbar;name&lowbar;&lowbar;&equals;&equals;&amp;&num;39&semi;&lowbar;&lowbar;main&lowbar;&lowbar;&amp;&num;39&semi;的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25gnexq.html">机器学习算法中如何选取超参数：学习速率、正则项系数、minibatch size</a>
		</li>
						<li><a href="https://www.batexi.com/a/960lez49.html">sxstrace启动&period;bat</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mje17r8.html">理解linux sed命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o415ylq.html">IDEA安装使用 VisualVM 及VisualVM 远程监视</a>
		</li>
						<li><a href="https://www.batexi.com/a/9636zdy9.html">css -- 运用&commat;media实现网页自适应中的几个关键分辨率</a>
		</li>
						<li><a href="https://www.batexi.com/a/90dvv538.html">shell脚本实例二</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pme7vd9.html">Remote procedure call &lpar;RPC&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwomnm39.html">C&num;如何表格型数据导出到Excel？</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8z1pdj39.html">Struts2技术内幕-----第七章</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmdy3k9.html">bzoj 3626&colon; &lbrack;LNOI2014&rsqb;LCA 离线&plus;树链剖分</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k163p79.html">BuzzSumo：什么样的文章能获得疯转？（基于1亿篇文章大数据分析&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y5em0q.html">Git 忽略已经提交的文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn6or0q.html">linux哪个版本好</a>
			</li>
						<li><a href="https://www.batexi.com/a/96onj549.html">【 POJ - 3801】Crazy Circuits&lpar;有源汇、上下界最小流&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxngw4j8.html">在linux中使用php将word文档转为pdf</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxngnez8.html">MyEclipse6&period;5安装SVN插件的三种方法z</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v5vxn8.html">Android sqlite数据库存取图片信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1k1nz9.html">14&period;7&period;4 InnoDB File-Per-Table Tablespaces</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
